#ifndef GETOPTS_H
#define GETOPTS_H

#include <string>

struct VALUE_OPT
	{
	const char *m_pstrName;
	const char *m_pstrValue;
	};

struct FLAG_OPT
	{
	const char *m_pstrName;
	bool m_bSet;
	};

extern VALUE_OPT ValueOpts[];
extern int ValueOptCount;

extern FLAG_OPT FlagOpts[];
extern int FlagOptCount;

extern bool g_ShowProgress;
extern const char *g_DateTime;
extern const char *g_ProgramName;

void Usage();
bool FlagOpt(const char *Name);
const char *ValueOpt(const char *Name);
const char *RequiredValueOpt(const char *Name);
void ProcessArgVect(int argc, char *argv[]);
bool IntOpt(const char *Name, unsigned *ptrValue);
bool SignedIntOpt(const char *Name, int *ptrValue);
unsigned RequiredIntOpt(const char *Name);
bool FloatOpt(const char *Name, double *ptrValue);
double RequiredFloatOpt(const char *Name);
std::string &GetCmdLine(std::string &s);
bool FloatOptf(const char *Name, float *ptrValue);

#endif	// GETOPTS_H
