#ifndef gridder_h
#define gridder_h

class Gridder
	{
public:
	Gridder();
	uns GetCellCount() const;
	void ComputeGrid(ptrGetQFn GetQ, const char *CSVFileName = 0);
	void CellIndexToCoords(uns CellIndex, vector<uns> &Coords) const;
	uns CoordsToCellIndex(const vector<uns> &Coords) const;
	void CellIndexToParams(uns CellIndex, ParamVec &Params) const;
	uns GetMinusDeltaCell(uns CellIndex, uns ParamIndex) const;
	uns GetPlusDeltaCell(uns CellIndex, uns ParamIndex) const;
	double GetMinusGradient(uns CellIndex, uns ParamIndex) const;
	double GetPlusGradient(uns CellIndex, uns ParamIndex) const;
	double GetAvgGradient(uns CellIndex, uns ParamIndex) const;
	void GetGradient(uns CellIndex, ParamVec &Grads) const;
	double GetParamStep(uns ParamIndex) const;
	bool IsPartialLocalOptimum(uns CellIndex, uns ParamIndex) const;
	bool IsLocalOptimum(uns CellIndex) const;
	void GetLocalOptima(vector<uns> &CellIndexes) const;
	void LogCells(const vector<uns> &CellIndexes) const;
	void SortCellIndexesByQ(vector<uns> &CellIndexes) const;
	void InitFromCmdLine();

public:
	uns m_ActiveParamCount;
	vector<uns> m_GridSizes;
	vector<double> m_Qs;
	vector<ParamVec> m_ParamVecs;
	ParamVec m_Lo;
	ParamVec m_Hi;
	FILE *m_fCSV;
	};

#endif // gridder_h
