#if	linux || __linux__
#include <sys/time.h>
#include <sys/resource.h>
#include <unistd.h>
#include <errno.h>
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>

double GetRAMSize()
	{
	const double DEFAULT_RAM = 1e9;
	static double RAMMB = 0;
	if (RAMMB != 0)
		return RAMMB;

	int fd = open("/proc/meminfo", O_RDONLY);
	if (-1 == fd)
		{
		RAMMB = DEFAULT_RAM;
		return DEFAULT_RAM;
		}

	char Buffer[128];
	int n = read(fd, Buffer, sizeof(Buffer) - 1);
	close(fd);
	fd = -1;

	if (n <= 0)
		{
		RAMMB = DEFAULT_RAM;
		return DEFAULT_RAM;
		}

	Buffer[n] = 0;
	char *pMem = strstr(Buffer, "Mem: ");
	if (0 == pMem)
		{
		RAMMB = DEFAULT_RAM;
		return DEFAULT_RAM;
		}
	double Bytes = atof(pMem+4);
	return Bytes;
	}

static double g_uPeakMemUseBytes;

double GetMaxMemUseBytes()
	{
	return g_uPeakMemUseBytes;
	}

double GetPeakMemUseBytes()
	{
	return GetMaxMemUseBytes();
	}

double GetMemUseBytes()
	{
	static char statm[64];
	static int PageSize = 1;
	if (0 == statm[0])
		{
		PageSize = sysconf(_SC_PAGESIZE);
		pid_t pid = getpid();
		sprintf(statm, "/proc/%d/statm", (int) pid);
		}

	int fd = open(statm, O_RDONLY);
	if (-1 == fd)
		return 1000000;
	char Buffer[64];
	int n = read(fd, Buffer, sizeof(Buffer) - 1);
	close(fd);
	fd = -1;

	if (n <= 0)
		return 1000000;

	Buffer[n] = 0;
	double Pages = atof(Buffer);

	double uBytes = Pages*PageSize;
	if (uBytes > g_uPeakMemUseBytes)
		g_uPeakMemUseBytes = uBytes;
	return uBytes;
	}

void OSInit()
	{
	}

#endif
