#ifndef	LOTYPES_H
#define LOTYPES_H

// low-level types, may change for different
// compiler/hardware platforms.

typedef unsigned char byte;
typedef unsigned short uint16;
typedef unsigned uint32;
typedef int int32;
typedef double float32;
typedef signed char int8;
typedef unsigned char uint8;

#ifdef _MSC_VER

typedef __int64 int64;
typedef unsigned __int64 uint64;
typedef __int64 off64_t;

#define INT64_PRINTF		"lld"
#define UINT64_PRINTF		"llu"

#define SIZE_T_PRINTF		"u"
#define OFF64_T_PRINTF		"lld"

#define INT64_PRINTFX		"llx"
#define UINT64_PRINTFX		"llx"

#define SIZE_T_PRINTFX		"x"
#define OFF64_T_PRINTFX		"llx"

#elif defined(__x86_64__)
#include <sys/types.h>

typedef long int64;
typedef unsigned long uint64;
//typedef off_t off64_t;

#define INT64_PRINTF		"ld"
#define UINT64_PRINTF		"lu"

#define SIZE_T_PRINTF		"lu"
#define OFF64_T_PRINTF		"ld"

#define INT64_PRINTFX		"lx"
#define UINT64_PRINTFX		"lx"

#define SIZE_T_PRINTFX		"lx"
#define OFF64_T_PRINTFX		"lx"

#else
#include <sys/types.h>

typedef long long int64;
typedef unsigned long long uint64;
//typedef off_t off64_t;

#define INT64_PRINTF		"lld"
#define UINT64_PRINTF		"llu"

#define SIZE_T_PRINTF		"u"
#define OFF64_T_PRINTF		"lld"

#define INT64_PRINTFX		"llx"
#define UINT64_PRINTFX		"llx"

#define SIZE_T_PRINTFX		"x"
#define OFF64_T_PRINTFX		"llx"
#endif

#define d64		INT64_PRINTF
#define	u64		UINT64_PRINTF
#define	x64		UINT64_PRINTFX

const uint64 UINT64_MAX			= (~((uint64) 0));

#if	defined(__APPLE_CC__)
#define OFF64_T_MAX	UINT64_MAX
#else
const off64_t OFF64_T_MAX		= UINT64_MAX;
#endif

#endif	// LOTYPES_H
