#ifndef msaset_h
#define msaset_h

class MSASet
	{
public:
	MSASet()
		{
		Clear();
		}
	uns GetCount() const
		{
		return SIZE(m_RefMSAs);
		}
	void Clear();
	void FromFile(const char *FileName);
	void ToFile(const char *FileName) const;
	void MSAToFile(FILE *f, uns MSAIndex) const;
	uns GetSeqCount() const;
	uns GetSeqCount(uns MSAIndex) const;
	uns GetPairCount() const;
	uns GetPairCount(uns MSAIndex) const;
	void AddMSA(const string &Name, const vector<string> &MSA,
	  const vector<string> &Labels);
	void GetPWSet(const vector<uns> &MSAIndexes,
	  const vector<pair<uns,uns> > &SeqIndexes,
	  const vector<double> &PairWeights, PWSet &Set) const;
	void GetAllPairs(PWSet &Set, bool MemSave = false) const;
	void GetPWSubset(uns PairCount, PWSet &P) const;
	void GetSubset(MSASet &Set, uns MaxMSAs, uns MaxSeqsPerMSA) const;
	uns GetMaxSeqLength(uns MSAIndex) const;

	const vector<string> &GetLabels(uns Index) const
		{
		asserta(Index < SIZE(m_LabelVec));
		return m_LabelVec[Index];
		}

	const vector<string> &GetRefMSA(uns Index) const
		{
		asserta(Index < SIZE(m_RefMSAs));
		return m_RefMSAs[Index];
		}

	const vector<string> &GetRefLabels(uns Index) const
		{
		asserta(Index < SIZE(m_RefLabelVec));
		return m_RefLabelVec[Index];
		}

	const vector<string> &GetUngappedSeqs(uns Index) const
		{
		asserta(Index < SIZE(m_UngappedSeqs));
		return m_UngappedSeqs[Index];
		}

	const string &GetName(uns Index) const
		{
		asserta(Index < SIZE(m_Names));
		return m_Names[Index];
		}

private:
	vector<vector<string> > m_RefMSAs;
	vector<vector<string> > m_UngappedSeqs;
	vector<vector<string> > m_LabelVec;
	vector<vector<string> > m_RefLabelVec;
	vector<string> m_Names;
	};

#endif // msaset_h
