#ifndef paramvec_h
#define paramvec_h

#include "getopts.h"
#include "alnparam.h"

void Round10(double x, unsigned SigFig, int &Mantissa, int &Exponent);

class ParamVec
	{
public:
	void Clear();
	ParamVec();
	void Zero(double mf = 1.0);
	size_t size() const;
	void Set(uns Param, double Value);
	double Get(uns Param) const;
	void SetAlpha(uns Param, double Alpha);
	static void SetActive(uns Param, bool On = true);
	static bool IsActive(uns Param);
	static bool IsActiveOrMF(uns Param);
	static uns GetActiveParamCount();
	static uns ActiveIndexToIndex(uns ActiveParamIndex);
	static uns IndexToActiveIndex(uns ParamIndex);
	double GetActiveParam(uns ActiveParamIndex) const;
	void FromCmdLine();
	string &ToStr(string &Str) const;
	void LogMe(bool NL = false, bool Scale = false) const;
	void LogAll() const;
	string &ToCmdLine(string &Opts) const;
	string &ToSepStr(string &Str, char Sep = ';') const;
	void LogRow(bool DoScale = true) const;
	static void LogRowHdr1(char c = 0);
	static void LogRowHdr2();
	bool operator<(const ParamVec &rhs) const;
	void Div(double x, bool Do_mf = false);
	static void FixMF(bool Fix);
	static bool IsNegativeParam(uns ParamIndex);
	void Normalize();
	uns GetDAL() const;
	static bool InitAlphas();

public:
	static vector<bool> m_Active;
	static bool m_FixMF;
	static double m_Alphas[AlnParamCount];

private:
	vector<float> m_Vec;
	};

#define NULL_PARAMS	((const ParamVec &) (*(ParamVec *) 0))

#endif //  paramvec_h
