#include "utils.h"
#include "getopts.h"

VALUE_OPT ValueOpts[] =
	{
	{ "log",				0 },

	{ "learn",				0 },
	{ "strain",				0 },
	{ "trainms",			0 },
	{ "alnpwset",			0 },
	{ "alnppset",			0 },
	{ "alnmsaset",			0 },
	{ "getprofpairs",		0 },
	{ "mksubset",			0 },
	{ "inferindels",		0 },

	{ "g",					0 },
	{ "tg",					0 },
	{ "dg",					0 },
	{ "mg",					0 },
	{ "dx",					0 },
	{ "e",					0 },
	{ "te",					0 },
	{ "me",					0 },
	{ "de",					0 },
	{ "mf",					0 },
	{ "mp",					0 },
	{ "h",					0 },
	{ "b",					0 },

	{ "mx",					0 },
	{ "mx2",				0 },

	{ "inititers",			0 },
	{ "maxiters",			0 },
	{ "conviters",			0 },
	{ "inititers2",			0 },
	{ "learniters",			0 },
	{ "learniters2",		0 },
	{ "rate",				0 },
	{ "ratefrom",			0 },
	{ "rateto",				0 },
	{ "rate2",				0 },
	{ "in",					0 },
	{ "out",				0 },
	{ "hillclimb",			0 },
	{ "inaps",				0 },
	{ "outaps",				0 },
	{ "subset",				0 },
	{ "subset1",			0 },
	{ "subset2",			0 },
	{ "kbest",				0 },
	{ "maxseqs",			0 },
	{ "maxmsas",			0 },
	{ "k",					0 },
	{ "u",					0 },
	{ "k2",					0 },
	{ "qpct",				0 },
	{ "qpct2",				0 },
	{ "mindq",				0 },
	{ "maxdq",				0 },
	{ "targetdq",			0 },
	{ "seed",				0 },
	{ "lambda",				0 },
	{ "logfrom",			0 },
	{ "logto",				0 },
	{ "progalign",			0 },
	{ "tree",				0 },
	{ "dimerstats",			0 },
	{ "ppscore",			0 },
	{ "stripgapcols",		0 },
	{ "setname",			0 },
	{ "trees",				0 },
	{ "termgaps",			0 },
	{ "refine",				0 },
	{ "hydro",				0 },
	{ "hydrow",				0 },
	{ "hydrov",				0 },
	{ "hydrog",				0 },
	{ "window",				0 },
	{ "minscore",			0 },
	{ "minlen",				0 },
	{ "grid",				0 },
	{ "gridg4",				0 },
	{ "gridsize",			0 },
	{ "paths",				0 },
	{ "pop",				0 },

	{ "glo",				0 },
	{ "ghi",				0 },
	{ "ng",					0 },

	{ "elo",				0 },
	{ "ehi",				0 },
	{ "ne",					0 },

	{ "tglo",				0 },
	{ "tghi",				0 },
	{ "ntg",				0 },

	{ "mglo",				0 },
	{ "mghi",				0 },
	{ "nmg",				0 },

	{ "telo",				0 },
	{ "tehi",				0 },
	{ "nte",				0 },

	{ "melo",				0 },
	{ "mehi",				0 },
	{ "nme",				0 },

	{ "dglo",				0 },
	{ "dghi",				0 },
	{ "ndg",				0 },

	{ "delo",				0 },
	{ "dehi",				0 },
	{ "nde",				0 },

	{ "dxlo",				0 },
	{ "dxhi",				0 },
	{ "ndx",				0 },

	{ "maxdirs",			0 },
	{ "mindq",				0 },
	{ "maxdq",				0 },
	{ "mindp",				0 },
	{ "maxdp",				0 },

	{ "maxdirs2",			0 },
	{ "mindq2",				0 },
	{ "maxdq2",				0 },
	{ "targetdq2",			0 },
	{ "mindp2",				0 },
	{ "maxdp2",				0 },

	{ "maxdirs3",			0 },
	{ "mindq3",				0 },
	{ "maxdq3",				0 },
	{ "targetdq3",			0 },
	{ "mindp3",				0 },
	{ "maxdp3",				0 },

	{ "mkxset",				0 },
	{ "testprof",			0 },
	{ "pairs",				0 },
	{ "testmea",			0 },
	{ "testfbp",			0 },
	{ "model",				0 },
	{ "csv",				0 },
	{ "maxseqlen",			0 },
	{ "minwin",				0 },
	{ "maxwin",				0 },
	{ "loscore",			0 },
	{ "hiscore",			0 },
	{ "nscore",				0 },
	{ "findancs",			0 },
	{ "findhsps",			0 },
	{ "findsps",			0 },
	{ "findmams",			0 },
	{ "qscore",				0 },
	{ "ref",				0 },
	{ "consaln",			0 },
	{ "objscore",			0 },
	{ "gappenalty",			0 },
	{ "sps",				0 },
	{ "editdist",			0 },
	{ "dist",				0 },
	{ "distc",				0 },
	{ "alpha",				0 },
	{ "fastclust",			0 },
	{ "psrefine",			0 },
	{ "weight",				0 },
	{ "f",					0 },
	{ "kmersel",			0 },
	{ "testwt",				0 },
	};
int ValueOptCount = sizeof(ValueOpts)/sizeof(ValueOpts[0]);

FLAG_OPT FlagOpts[] =
	{
	{ "quiet",				0 },
	{ "loss",				0 },
	{ "trace",				0 },
	{ "logalns",			0 },
	{ "logprofs",			0 },
	{ "test",				0 },
	{ "savesubsets",		0 },
	{ "prof",				0 },
	{ "all",				0 },
	{ "verbose",			0 },
	{ "randomize",			0 },
	{ "logxform",			0 },
	{ "logdp",				0 },
	{ "logtb",				0 },
	{ "cmpdp",				0 },
	{ "logdimermxscore",	0 },
	{ "2",					0 },
	{ "strip",				0 },
	{ "multi",				0 },
//	{ "unitweights",		0 },
	{ "mafft",				0 },
	{ "dropoff",			0 },
	{ "nodropoff",			0 },
	{ "prefab",				0 },
	{ "mea",				0 },
	{ "fast",				0 },
	{ "hspopt",				0 },
	{ "dump",				0 },
	{ "memsave",			0 },
	{ "msa",				0 },
	{ "fast3",				0 },
	{ "nncluster",			0 },
	{ "fb",					0 },
	{ "testmybit",			0 },
	{ "testmybitb",			0 },
	{ "la",					0 },
	{ "nr",					0 },
	{ "infer",				0 },
	{ "GC",					0 },
	{ "qisgc",				0 },
	{ "logdpmemexpand",		0 },
	};
int FlagOptCount = sizeof(FlagOpts)/sizeof(FlagOpts[0]);
