#ifndef pwa_h
#define pwa_h

class ParamVec;

enum TermGapStyle
	{
	TGS_Free,
	TGS_ExtOnly,
	TGS_Half,
	TGS_Full,
	};

class PairWiseAligner
	{
public:
	virtual ~PairWiseAligner() {}
	virtual void SubclassInitParamsFromCmdLine(ParamVec &Params) const = 0;
	void SetParams(ParamVec &Params) const;
	virtual void SubclassSetParams(ParamVec &Params) const = 0;
	virtual SCORE NW(const vector<byte> &A, const vector<byte> &B,
	  const ParamVec &Params, bool DoLoss, 
	  bool ALeftTrunc, bool ARightTrunc, bool BLeftTrunc, bool BRightTrunc,
	  string &Path) const = 0;
	virtual const char *GetName() const = 0;
	virtual void SetActiveParams() const = 0;
	virtual void SetOpts() {}

	static void InitFromCmdLine();
	static void InitFromCmdLine(ParamVec &Params);
	};

class PWA2 : public PairWiseAligner
	{
public:
	PWA2()
		{
		m_TermGapStyle = TGS_Full;
		}
	virtual void SubclassInitParamsFromCmdLine(ParamVec &Params) const;
	virtual void SubclassSetParams(ParamVec &Params) const;
	virtual SCORE NW(const vector<byte> &A, const vector<byte> &B,
	  const ParamVec &Params, bool DoLoss, 
	  bool ALeftTrunc, bool ARightTrunc, bool BLeftTrunc, bool BRightTrunc,
	  string &Path) const;
	virtual const char *GetName() const { return "g2"; }
	virtual void SetActiveParams() const;
	virtual void SetOpts();

public:
	int m_TermGapStyle;	// 0=half, 1=ext only, 2=full
	};

class PWA4 : public PairWiseAligner
	{
public:
	virtual void SubclassInitParamsFromCmdLine(ParamVec &Params) const;
	virtual void SubclassSetParams(ParamVec &Params) const;
	virtual SCORE NW(const vector<byte> &A, const vector<byte> &B,
	  const ParamVec &Params, bool DoLoss, 
	  bool ALeftTrunc, bool ARightTrunc, bool BLeftTrunc, bool BRightTrunc,
	  string &Path) const;
	virtual const char *GetName() const { return "g4"; }
	virtual void SetActiveParams() const;
	};

extern PairWiseAligner *g_PWA;

#endif // pwa_h
