#include "utils.h"
#include <string>

const unsigned BLOCK_SIZE = 60;

void WriteFasta(FILE *f, const char *SeqData, unsigned Length)
	{
	for (unsigned Pos = 0; Pos < Length; Pos += BLOCK_SIZE)
		{
		unsigned Bytes = Length - Pos;
		if (Bytes > BLOCK_SIZE)
			Bytes = BLOCK_SIZE;
		WriteStdioFile(f, SeqData + Pos, Bytes);
		WriteStdioFileStr(f, "\n");
		}
	}

void WriteFasta(FILE *f, const std::string &Seq)
	{
	WriteFasta(f, Seq.c_str(), (unsigned) Seq.size());
	}

void WriteFasta(FILE *f, const std::string &Label, const std::string &Seq)
	{
	fprintf(f, ">%s\n", Label.c_str());
	WriteFasta(f, Seq.c_str(), (unsigned) Seq.size());
	}
